"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getRemoveFormatButton=exports.getFormatName=exports.registerMultipleClassFormatType=void 0;var _react=_interopRequireDefault(require("react"));var _utils=require("../utils");var _constant=require("../constant");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _extends(){_extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};return _extends.apply(this,arguments);}function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable;});keys.push.apply(keys,symbols);}return keys;}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=arguments[i]!=null?arguments[i]:{};if(i%2){ownKeys(Object(source),true).forEach(function(key){_defineProperty(target,key,source[key]);});}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source));}else{ownKeys(Object(source)).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key));});}}return target;}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true});}else{obj[key]=value;}return obj;}var isValidRemoveFormatButton=_utils.Helpers.isValidRemoveFormatButton,getRemoveFormatFunction=_utils.Helpers.getRemoveFormatFunction;var Button=wp.components.Button;var _wp$data=wp.data,dispatch=_wp$data.dispatch,select=_wp$data.select;/**
 * @param {object} settings settings
 * @returns {boolean} is valid?
 */var validateName=function validateName(settings){if(typeof settings.name!=='string'){window.console.error('Format names must be strings.');return false;}if(!/^[a-z][a-z0-9-]*\/[a-z][a-z0-9-]*$/.test(settings.name)){window.console.error('Format names must contain a namespace prefix, include only lowercase alphanumeric characters or dashes, and start with a letter. Example: my-plugin/my-custom-format');return false;}if(select('core/rich-text').getFormatType(settings.name)){window.console.error('Format "'+settings.name+'" is already registered.');return false;}return true;};/**
 * @param {object} settings settings
 * @returns {boolean} is valid?
 */var validateTagName=function validateTagName(settings){if(typeof settings.tagName!=='string'||settings.tagName===''){window.console.error('Format tag names must be a string.');return false;}return true;};/**
 * @param {object} settings settings
 * @returns {boolean} is valid?
 */var validateClassName=function validateClassName(settings){if((typeof settings.className!=='string'||settings.className==='')&&settings.className!==null){window.console.error('Format class names must be a string, or null to handle bare elements.');return false;}if(!/^([_a-zA-Z]+[_a-zA-Z0-9-]*)(\s+[_a-zA-Z]+[_a-zA-Z0-9-]*)*$/.test(settings.className)){window.console.error('A class name must begin with a letter, followed by any number of hyphens, letters, or numbers.');return false;}return true;};/**
 * @param {object} settings settings
 * @returns {boolean} is valid?
 */var validateTitle=function validateTitle(settings){if(!('title'in settings)||settings.title===''){window.console.error('The format "'+settings.name+'" must have a title.');return false;}if(typeof settings.title!=='string'){window.console.error('Format titles must be strings.');return false;}return true;};/**
 * @param {object} settings settings
 * @returns {boolean} is valid?
 */var validateKeywords=function validateKeywords(settings){if('keywords'in settings&&settings.keywords.length>3){// eslint-disable-line no-magic-numbers
window.console.error('The format "'+settings.name+'" can have a maximum of 3 keywords.');return false;}return true;};/**
 * @param {object} settings settings
 * @returns {boolean} is valid?
 */var checkRegistered=function checkRegistered(settings){if(settings.className===null){var formatTypeForBareElement=select('core/rich-text').getFormatTypeForBareElement(settings.tagName);if(formatTypeForBareElement){window.console.error("Format \"".concat(formatTypeForBareElement.name,"\" is already registered to handle bare tag name \"").concat(settings.tagName,"\"."));return true;}}else{var formatTypeForClassName=select('core/rich-text').getFormatTypeForClassName(settings.className);if(formatTypeForClassName){window.console.error("Format \"".concat(formatTypeForClassName.name,"\" is already registered to handle class name \"").concat(settings.className,"\"."));return true;}}return false;};/**
 * @param {string} name name
 * @param {object} settings strings
 * @returns {object|null} registered settings
 * @private
 */var registerMultipleClassFormatType=function registerMultipleClassFormatType(name,settings){settings=_objectSpread({name:name},settings);if(!validateName(settings)){return null;}if(!validateTagName(settings)){return null;}if(!validateClassName(settings)){return null;}if(!validateTitle(settings)){return null;}if(!validateKeywords(settings)){return null;}if(checkRegistered(settings)){return null;}dispatch('core/rich-text').addFormatTypes(settings);return settings;};/**
 * @param {string} name name
 * @returns {string} format name
 */exports.registerMultipleClassFormatType=registerMultipleClassFormatType;var getFormatName=function getFormatName(name){return"".concat(_constant.PLUGIN_NAME,"/").concat(name);};/**
 * @param {string} label label
 * @param {object} settings settings
 * @returns {function} remove format button
 */exports.getFormatName=getFormatName;var getRemoveFormatButton=function getRemoveFormatButton(label){var settings=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{isSecondary:true};return function(args){return isValidRemoveFormatButton(args)?wp.element.createElement(Button,_extends({},settings,{onClick:getRemoveFormatFunction(args)}),label):null;};};exports.getRemoveFormatButton=getRemoveFormatButton;