"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getFormatState=exports.registerGroupedFormatType=exports.registerFormatTypeGroup=void 0;var _react=_interopRequireDefault(require("react"));var _components=require("../components");var _richText=require("./rich-text");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable;});keys.push.apply(keys,symbols);}return keys;}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=arguments[i]!=null?arguments[i]:{};if(i%2){ownKeys(Object(source),true).forEach(function(key){_defineProperty(target,key,source[key]);});}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source));}else{ownKeys(Object(source)).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key));});}}return target;}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true});}else{obj[key]=value;}return obj;}function _objectWithoutProperties(source,excluded){if(source==null)return{};var target=_objectWithoutPropertiesLoose(source,excluded);var key,i;if(Object.getOwnPropertySymbols){var sourceSymbolKeys=Object.getOwnPropertySymbols(source);for(i=0;i<sourceSymbolKeys.length;i++){key=sourceSymbolKeys[i];if(excluded.indexOf(key)>=0)continue;if(!Object.prototype.propertyIsEnumerable.call(source,key))continue;target[key]=source[key];}}return target;}function _objectWithoutPropertiesLoose(source,excluded){if(source==null)return{};var target={};var sourceKeys=Object.keys(source);var key,i;for(i=0;i<sourceKeys.length;i++){key=sourceKeys[i];if(excluded.indexOf(key)>=0)continue;target[key]=source[key];}return target;}var Fragment=wp.element.Fragment;var formatNames={};var groups={};var inspectorGroups={};var groupSettings={};var useInspectorSettings={};/**
 * @param {string} name group name
 * @param {object} setting setting
 * @returns {object} registered setting
 */var registerFormatTypeGroup=function registerFormatTypeGroup(name){var setting=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};groupSettings[name]=Object.assign({},getGroupSetting(name),setting);return groupSettings[name];};/**
 * @param {string} name group name
 * @returns {{icon: string, position: string, label: string, className: undefined, menuClassName: undefined, inspectorSettings, toolbarGroup, useContrastChecker, additionalInspectors}} setting
 */exports.registerFormatTypeGroup=registerFormatTypeGroup;var getGroupSetting=function getGroupSetting(name){return name in groupSettings?groupSettings[name]:getDefaultSetting(name);};/**
 * @param {string} name group name
 * @returns {{icon: string, position: string, label: string, className: undefined, menuClassName: undefined, inspectorSettings, toolbarGroup, useContrastChecker, additionalInspectors}} setting
 */var getDefaultSetting=function getDefaultSetting(name){return{icon:'admin-customizer',position:'top right',label:name,className:undefined,menuClassName:undefined,inspectorSettings:{},toolbarGroup:undefined,useContrastChecker:false,additionalInspectors:[]};};/**
 * @returns {Array.<Array.<object>>} grouped slots
 */var getToolbarGroupedSlots=function getToolbarGroupedSlots(){var grouped={};Object.keys(groups).forEach(function(key){var setting=getGroupSetting(key in useInspectorSettings?useInspectorSettings[key]:key);var toolbarGroup=setting.toolbarGroup;if(!(toolbarGroup in grouped)){grouped[toolbarGroup]=[];}grouped[toolbarGroup].push({Slot:groups[key].Slot,setting:setting});});return Object.values(grouped);};/**
 * @param {string} name name
 * @param {string} title title
 * @param {string} tagName tag name
 * @param {string} className class name
 * @param {function?} create create component function
 * @param {function?} createInspector create inspector component function
 * @param {string?} group group
 * @param {string?} inspectorGroup inspector group
 * @param {object} settings settings
 * @return {object|null} registered settings
 */var registerGroupedFormatType=function registerGroupedFormatType(_ref){var name=_ref.name,_ref$title=_ref.title,title=_ref$title===void 0?name:_ref$title,_ref$tagName=_ref.tagName,tagName=_ref$tagName===void 0?'span':_ref$tagName,_ref$className=_ref.className,className=_ref$className===void 0?name:_ref$className,create=_ref.create,createInspector=_ref.createInspector,_ref$group=_ref.group,group=_ref$group===void 0?name:_ref$group,inspectorGroup=_ref.inspectorGroup,settings=_objectWithoutProperties(_ref,["name","title","tagName","className","create","createInspector","group","inspectorGroup"]);if(undefined===name){return null;}var formatName=(0,_richText.getFormatName)(name);if(formatName in formatNames){return null;}var isFirst=!Object.keys(formatNames).length;formatNames[formatName]=formatName;if(settings&&'useInspectorSetting'in settings&&settings.useInspectorSetting&&inspectorGroup){useInspectorSettings[group]=inspectorGroup;}return(0,_richText.registerMultipleClassFormatType)(formatName,_objectSpread({title:title,tagName:tagName,className:className,edit:onEdit(name,formatName,group,inspectorGroup,create,createInspector,isFirst,settings)},settings));};/**
 * @param {string} formatName format name
 * @param {object} args args
 * @returns {object} format state
 */exports.registerGroupedFormatType=registerGroupedFormatType;var getFormatState=function getFormatState(formatName,args){var isActive=args.isActive||!args.value.activeFormats||args.value.activeFormats.map(function(format){return format.type;}).includes(formatName);var isDisabled=!isActive&&args.value.start===args.value.end;return{isDisabled:isDisabled,isDropdownDisabled:isDisabled&&args.value.start!==undefined};};/**
 * @param {string} name name
 * @param {string} formatName format name
 * @param {string|undefined} group group
 * @param {string|undefined} inspectorGroup inspector group
 * @param {function|undefined} create create component function
 * @param {function|undefined} createInspector create inspector component function
 * @param {boolean} isFirst is first?
 * @param {object} settings settings
 * @returns {function(*=): *} component
 */exports.getFormatState=getFormatState;var onEdit=function onEdit(name,formatName,group,inspectorGroup,create,createInspector,isFirst,settings){return function(args){var newArgs=Object.assign({},args,getFormatState(formatName,args));var component=createComponent(create,group,newArgs,name,formatName,settings);var inspector=createComponent(createInspector,inspectorGroup,newArgs,name,formatName,settings);return wp.element.createElement(Fragment,null,createComponentFill(group,component),createInspectorFill(inspectorGroup,inspector),createSlot(isFirst,newArgs));};};/**
 * @param {function} createFunction create function
 * @param {string|undefined} group group
 * @param {object} args args
 * @param {string} name name
 * @param {string} formatName format name
 * @param {object} settings settings
 * @returns {null|*} component
 */var createComponent=function createComponent(createFunction,group,args,name,formatName,settings){var component=!!group&&typeof createFunction==='function'?createFunction({args:args,name:name,formatName:formatName}):null;if(component){return Object.assign({},component,{props:Object.assign({},component.props,{isActive:args.isActive,isDisabled:args.isDisabled,isDropdownDisabled:args.isDropdownDisabled,formatName:formatName,propertyName:settings.propertyName})});}return component;};/**
 * @param {string|undefined} group group
 * @param {object} component component
 * @param {object} groups groups
 * @param {function} createFillSlotFunction create fill slot function
 * @returns {null|*} fill
 */var createFill=function createFill(group,component,groups,createFillSlotFunction){if(!group||!component){return null;}if(!(group in groups)){groups[group]=createFillSlotFunction(group);}var Fill=groups[group].Fill;return wp.element.createElement(Fill,null,component);};/**
 * @param {string|undefined} group group
 * @param {object} component component
 * @returns {*} fill
 */var createComponentFill=function createComponentFill(group,component){return createFill(group,component,groups,_components.GroupedControls);};/**
 * @param {string|undefined} inspectorGroup inspector group
 * @param {object} component component
 * @returns {*} fill
 */var createInspectorFill=function createInspectorFill(inspectorGroup,component){return createFill(inspectorGroup,component,inspectorGroups,_components.GroupedInspectors);};/**
 * @param {boolean} isFirst is first?
 * @param {object} args args
 * @returns {null|*} slot
 */var createSlot=function createSlot(isFirst,args){return isFirst?wp.element.createElement(Fragment,null,(0,_components.ToolbarDropdown)(getToolbarGroupedSlots()),Object.keys(inspectorGroups).map(function(key,index){return(0,_components.InspectorComponent)(inspectorGroups[key].Slot,getGroupSetting(key),args,index);})):null;};