"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.default=void 0;var _react=_interopRequireDefault(require("react"));var _classnames=_interopRequireDefault(require("classnames"));var _utils=require("../utils");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _extends(){_extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};return _extends.apply(this,arguments);}function _slicedToArray(arr,i){return _arrayWithHoles(arr)||_iterableToArrayLimit(arr,i)||_unsupportedIterableToArray(arr,i)||_nonIterableRest();}function _nonIterableRest(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen);}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++){arr2[i]=arr[i];}return arr2;}function _iterableToArrayLimit(arr,i){if(typeof Symbol==="undefined"||!(Symbol.iterator in Object(arr)))return;var _arr=[];var _n=true;var _d=false;var _e=undefined;try{for(var _i=arr[Symbol.iterator](),_s;!(_n=(_s=_i.next()).done);_n=true){_arr.push(_s.value);if(i&&_arr.length===i)break;}}catch(err){_d=true;_e=err;}finally{try{if(!_n&&_i["return"]!=null)_i["return"]();}finally{if(_d)throw _e;}}return _arr;}function _arrayWithHoles(arr){if(Array.isArray(arr))return arr;}var _wp$components=wp.components,ToolbarGroup=_wp$components.ToolbarGroup,NavigableMenu=_wp$components.NavigableMenu,Button=_wp$components.Button;var BlockControls=wp.blockEditor.BlockControls;/**
 * @param {Array} fills fills
 * @param {object} setting setting
 * @returns {*} dropdown
 */var createDropdown=function createDropdown(fills,setting){var controls=fills.map(function(_ref){var _ref2=_slicedToArray(_ref,1),props=_ref2[0].props;return props;});var isActive=!!controls.filter(function(control){return control.isActive;}).length;var isDisabled=!controls.filter(function(control){return!control.isDisabled;}).length;var onClick=function onClick(props,control){return function(event){event.stopPropagation();props.onClose();if(control.onClick){control.onClick();}};};var label=setting.label,menuClassName=setting.menuClassName;return wp.element.createElement(_utils.Components.DropdownButton,_extends({},setting,{isActive:isActive,isDisabled:isDisabled,renderContent:function renderContent(props){return wp.element.createElement(NavigableMenu,{className:(0,_classnames.default)('components-dropdown-menu__menu',menuClassName),role:"menu","aria-label":label},controls.map(function(control,index){return wp.element.createElement(Button,{key:"dropdown-".concat(label,"-").concat(index),onClick:onClick(props,control),className:(0,_classnames.default)('components-dropdown-menu__menu-item',{'is-active':control.isActive}),icon:control.icon,role:"menuitem",disabled:control.isDisabled},control.title);}));}}));};/**
 * @param {Array} fills fills
 * @param {object} setting setting
 * @returns {*} component
 */var createComponent=function createComponent(fills,setting){return fills.length>1?createDropdown(fills,setting):fills[0][0];};/* eslint-disable-line no-magic-numbers */ /**
 * @param {Array.<Array.<object>>} groupedSlots grouped slots
 * @returns {*} dropdown
 * @constructor
 */var ToolbarDropdown=function ToolbarDropdown(groupedSlots){return wp.element.createElement(BlockControls,null,groupedSlots.map(function(slots,groupIndex){return wp.element.createElement("div",{key:"toolbar-dropdown-".concat(groupIndex),className:"editor-format-toolbar block-editor-format-toolbar"},wp.element.createElement(ToolbarGroup,null,slots.map(function(_ref3,index){var Slot=_ref3.Slot,setting=_ref3.setting;return wp.element.createElement(Slot,{key:"toolbar-dropdown-".concat(groupIndex,"-").concat(index)},function(fills){return!fills.length?null:createComponent(fills,setting);});})));}));};var _default=ToolbarDropdown;exports.default=_default;